#Remember to load the the processed data and obtain_coefs.R
require(MCMCpack)
require(strucchange)

#Use to deactivate models
activity=c(1,1,1,1,1,1,1,1,1)

#number of subject
sn=length(model2_beta_resp[,1])

#Number of subjects used to fit parameters
fitn=20

#Hacky way of getting only responsive subjects
#non-responsive bonus
penalty=100000
penvec=rep(penalty,sn)
penvec[str_mon_subj]=0

#load and clean data
#Constant
conslikevec= as.numeric(lapply(mean_reg_dots,logLik))-penvec
sortconslikevec=sort(conslikevec,decreasing=TRUE)
consusevec=which(conslikevec %in% sortconslikevec[1:fitn])[1:fitn]
consperfest=model1_alpha[consusevec]


#Binary
binlikevec= as.numeric(lapply(breaks_reg_noslope_opt_dots,logLik))-penvec
sortbinlikevec=sort(binlikevec,decreasing=TRUE)
binusevec=which(binlikevec %in% sortbinlikevec[1:fitn])[1:fitn]

binperfest1=model2_beta[binusevec,1]
binperfest2=model2_beta[binusevec,2]+model2_beta[binusevec,1]
binbreakest=model2_delta[binusevec]

#Affine with break

AffBrlikevec= as.numeric(lapply(breaks_dots,logLik))-penvec
sortAffBrlikevec=sort(AffBrlikevec,decreasing=TRUE)
AffBrusevec=which(AffBrlikevec %in% sortAffBrlikevec[1:fitn])[1:fitn]

AffBrint1est=pmax(0,model3_beta0[AffBrusevec]) 
#Replace some NAs
model3_delta[is.na(model3_delta)]=50
AffBrbreakest=model3_delta[AffBrusevec]
AffBrslope1est=pmin((1-AffBrint1est)/AffBrbreakest,pmax(0,model3_beta1[AffBrusevec]))
#Replace some NAs
model3_beta3[is.na(model3_beta3)]=0
AffBrslope2est=pmax(0,pmin((1-AffBrint1est-AffBrslope1est*AffBrbreakest)/(100-AffBrbreakest),model3_beta3[AffBrusevec]+model3_beta1[AffBrusevec]))
model3_beta2[is.na(model3_beta2)]=0
AffBrint2est=pmax(AffBrint1est+AffBrslope1est*AffBrbreakest-AffBrslope2est*AffBrbreakest,pmin(1-100*AffBrslope2est,model3_beta2[AffBrusevec]+model3_beta0[AffBrusevec]))


#affine
Afflikevec= as.numeric(lapply(reg_dots,logLik))-penvec
sortAfflikevec=sort(Afflikevec,decreasing=TRUE)
Affusevec=which(Afflikevec %in% sortAfflikevec[1:fitn])[1:fitn]

Affintest=model4_beta[Affusevec,1]
Affslopeest=pmax(0,pmin((1-Affintest)/100,model4_beta[Affusevec,2]))

#Quadratic
Quadlikevec= as.numeric(lapply(lpm2_reg_dots,logLik))-penvec
sortQuadlikevec=sort(Quadlikevec,decreasing=TRUE)
Quadusevec=which(Quadlikevec %in% sortQuadlikevec[1:fitn])[1:fitn]

Quadintest=model5_beta [Quadusevec,1]
Quadsqrest=pmax((Quadintest-1)/10000+0.0000001,pmin((1-Quadintest)/10000-0.000001,model5_beta [Quadusevec,3]))
Quadslopeest=pmax(pmax(0,-200*Quadsqrest)+0.000000001,pmin((-10000*Quadsqrest-Quadintest)/100-0.0000000001,model5_beta [Quadusevec,2]))

#Cubic
Cublikevec= as.numeric(lapply(lpm3_reg_dots,logLik))-penvec
sortCublikevec=sort(Cublikevec,decreasing=TRUE)
Cubusevec=which(Cublikevec %in% sortCublikevec[1:fitn])[1:fitn]

cubtype=vector('numeric')
cubintest=vector('numeric')
cubslopeest=vector('numeric')
cubsqrest=vector('numeric')
cubcubest=vector('numeric')
for(j in 1:fitn){
i=Cubusevec[j]
int=model6_beta[i,1]
slope=model6_beta[i,2]
sqr=model6_beta[i,3]
cub=model6_beta[i,4]
out=polyroot(c(int,slope,sqr,cub))
check=abs(Im(out))<10^-10
if(sum(check)<2){

cubtype[i]=1
cubintest[i]=pmax(0+0.000000001,pmin(1-0.000000001,model6_beta[i,1]))
cubcubest[i]=pmax(0+0.000000001,pmin((1-cubintest[i])/250000-0.00000000001,model6_beta[i,4]))
cubslopeest[i]=pmax(2500*(sqrt(3*cubcubest[i])-sqrt(abs(3*cubcubest[i]+(1-cubintest[i]-100^3*cubcubest[i]))/250000))^2+0.000000001,pmin(2500*(sqrt(3*cubcubest[i])+sqrt(abs(3*cubcubest[i]+(1-cubintest[i]-100^3*cubcubest[i]))/250000))^2-0.000000001,model6_beta[i,2]))
cubsqrest[i]=pmax(-sqrt(3*cubslopeest[i]*cubcubest[i])+0.000000001,pmin(min((1-cubintest[i]-100*cubslopeest[i]-100^3*cubcubest[i])/10000,sqrt(3*cubslopeest[i]*cubcubest[i]))-0.000000000001,model6_beta[i,3]))

}else{
realroots=Re(out[check])
realroots=sort(realroots)
if(realroots[1]<50&realroots[2]<50){

cubtype[i]=2
cubintest[i]=pmax(0+0.000000001,pmin(0.5-0.000000001,model6_beta[i,1]))
cubslopeest[i]=pmax(0+0.000000001,pmin((1-cubintest[i])/100-0.000000001,model6_beta[i,2]))
cubcubest[i]=pmax(0+0.000000001,pmin(min(1-cubintest[i]-100*cubslopeest[i],1-2*cubintest[i])/(100^3)-0.000000001,model6_beta[i,4]))
cubsqrest[i]=pmax(sqrt(3*cubcubest[i]*cubslopeest[i])+0.000000001,pmin((1-cubintest[i]-cubslopeest[i]*100-cubcubest[i]*100^3)/10000-0.000000001,model6_beta[i,3]))

}
if(realroots[1]>50&realroots[2]>50){

cubtype[i]=3
cubintest[i]=pmax(0+0.000000001,pmin(1-0.000000001,model6_beta[i,1]))
cubslopeest[i]=pmax(0+0.000000001,pmin(3*(1-cubintest[i])/100-0.000000001,model6_beta[i,2]))
cubcubest[i]=pmax(max(0,(50*cubslopeest[i]-cubintest[i]-1)/500000)+0.000000001,pmin(cubslopeest[i]/30000-0.000000001,model6_beta[i,4]))
cubsqrest[i]=pmax((-cubslopeest[i]-30000*cubcubest[i])/200+0.000000001,pmin(min(-sqrt(3*cubslopeest[i]*cubcubest[i]),(1-cubintest[i]-100*cubslopeest[i]-100^3*cubcubest[i])/10000)-0.000000001,model6_beta[i,3]))

}
if(realroots[1]<50&realroots[2]>50){

cubtype[i]=4
cubintest[i]=pmax(0+0.000000001,pmin(1-0.000000001,model6_beta[i,1]))
cubslopeest[i]=pmax(0+0.000000001,pmin((1-cubintest[i])/50-0.000000001,model6_beta[i,2]))
cubcubest[i]=pmax((50*cubslopeest[i]+cubintest[i]-1)/500000+0.0000000000000000000001,pmin(0-0.00000000000000000000001,model6_beta[i,4]))
cubsqrest[i]=pmax((-cubslopeest[i]-30000*cubcubest[i])/200+0.000000001,pmin((1-cubintest[i]-100*cubslopeest[i]-100^3*cubcubest[i])/10000-0.000000001,model6_beta[i,3]))

}
}
}

#Shannon
Shanlikevec= as.numeric(lapply(mle_dots,logLik))-penvec
sortShanlikevec=sort(Shanlikevec,decreasing=TRUE)
Shanusevec=which(Shanlikevec %in% sortShanlikevec[1:fitn])[1:fitn]

Shancostest=model7_alpha[Shanusevec]

#Normal
Normlikevec= as.numeric(lapply(normsig_dots,logLik))-penvec
sortNormlikevec=sort(Normlikevec,decreasing=TRUE)
Normusevec=which(Normlikevec %in% sortNormlikevec[1:fitn])[1:fitn]

Normcostest=model8_alpha[Normusevec]

#Tsallis
Tsallikevec= as.numeric(lapply(tsallis_dots,logLik))-penvec
sortTsallikevec=sort(Tsallikevec,decreasing=TRUE)
Tsalusevec=which(Tsallikevec %in% sortTsallikevec[1:fitn])[1:fitn]

Tsalcostest=model9_alphasigma[Tsalusevec,1]
Tsalentest=model9_alphasigma[Tsalusevec,2]

#Use only data from responsive subjects
inc_dots=inc_dots[str_mon_subj,] 
correct_dots=correct_dots[str_mon_subj,] 
true_dots=true_dots[str_mon_subj,] 

#Define functions to convert moments into model parameters

Beta_params=function(mean, var){
alpha=mean*((1-mean)*mean/var-1)
beta=((1-mean)*mean/var-1)-alpha
return(c(alpha,beta))
}

Gamma_params=function(mean,var){
k=mean^2/var
theta=var/mean
return(c(k,theta))
}

#Define parameter prior distributions
#Constant
#performance level (beta)
modconsperfest=consperfest
Con_Params=Beta_params(mean(modconsperfest),var(modconsperfest))
Con_alpha=Con_Params[1]
Con_beta=Con_Params[2]


#Binary
#first performance level (beta)
modbinperfest1=binperfest1
Bin_params1=Beta_params(mean(modbinperfest1),var(modbinperfest1))
Bin_alpha1=Bin_params1[1]
Bin_beta1=Bin_params1[2]

#High performance bonus (beta)
#transform parameter estimates
modbinperfest2=(binperfest2-binperfest1)/(1-binperfest1)
Bin_params2=Beta_params(mean(modbinperfest2),var(modbinperfest2))
Bin_alpha2=Bin_params2[1]
Bin_beta2=Bin_params2[2]

#Break (beta)
#transform parameter estimates
modbinbreakest=(binbreakest-5)/90
Bin_params_break=Beta_params(mean(modbinbreakest),var(modbinbreakest))
Bin_alpha_break=Bin_params_break[1]
Bin_beta_break=Bin_params_break[2]


#Affine with Break
#Intercept 1 (beta)
modAffBrint1est=AffBrint1est
AffBr_params_int1=Beta_params(mean(modAffBrint1est),var(modAffBrint1est))
AffBr_alpha_int1=AffBr_params_int1[1]
AffBr_beta_int1=AffBr_params_int1[2]

#Break location (beta)
modAffBrbreakest=(AffBrbreakest-5)/90
AffBr_params_break=Beta_params(mean(modAffBrbreakest),var(modAffBrbreakest))
AffBr_alpha_break=AffBr_params_break[1]
AffBr_beta_break=AffBr_params_break[2]

#Slope 1 (beta)
modAffBrslope1est=AffBrslope1est/((1-AffBrint1est)/AffBrbreakest)
AffBr_params_slope1=Beta_params(mean(modAffBrslope1est),var(modAffBrslope1est))
AffBr_alpha_slope1=AffBr_params_slope1[1]
AffBr_beta_slope1=AffBr_params_slope1[2]

#Slope 2 (beta)
modAffBrslope2est=AffBrslope2est/((1-AffBrint1est-AffBrbreakest*AffBrslope1est)/(100-AffBrbreakest))
AffBr_params_slope2=Beta_params(mean(modAffBrslope2est),var(modAffBrslope2est))
AffBr_alpha_slope2=AffBr_params_slope2[1]
AffBr_beta_slope2=AffBr_params_slope2[2]

#Intercept 2 (beta)
minint2est=AffBrint1est+AffBrbreakest*AffBrslope1est-AffBrslope2est*AffBrbreakest
modAffBrint2est=(AffBrint2est-minint2est)/((1-100*AffBrslope2est)-minint2est)
#replace nans
modAffBrint2est[is.na(modAffBrint2est)]=1
AffBr_params_int2=Beta_params(mean(modAffBrint2est),var(modAffBrint2est))
AffBr_alpha_int2=AffBr_params_int2[1]
AffBr_beta_int2=AffBr_params_int2[2]
#Beta parameterization does not work, so take absolute values
AffBr_alpha_int2=abs(AffBr_params_int2[1])
AffBr_beta_int2=abs(AffBr_params_int2[2])


#Affine
#Intercept (beta)
modAffintest=Affintest
Aff_params_int=Beta_params(mean(modAffintest),var(modAffintest))
Aff_alpha_int=Aff_params_int[1]
Aff_beta_int=Aff_params_int[2]

#Slope (beta)
modAffslopeest=100*Affslopeest/(1-Affintest)
Aff_params_slope=Beta_params(mean(modAffslopeest),var(modAffslopeest))
Aff_alpha_slope=Aff_params_slope[1]
Aff_beta_slope=Aff_params_slope[2]


#Quadratic
#Intercept (beta)
modQuadintest=Quadintest
Quad_params_int=Beta_params(mean(modQuadintest),var(modQuadintest))
Quad_alpha_int=Quad_params_int[1]
Quad_beta_int=Quad_params_int[2]

#Square Term (beta)
modQuadsqrest=(Quadsqrest+(1-Quadintest)/10000)/((1-Quadintest)/10000-(Quadintest-1)/10000)
Quad_params_sqr=Beta_params(mean(modQuadsqrest),var(modQuadsqrest))
Quad_alpha_sqr=Quad_params_sqr[1]
Quad_beta_sqr=Quad_params_sqr[2]

#Slope (beta)
quadminslope=pmax(0,-200*Quadsqrest)
modQuadslopeest=(Quadslopeest-quadminslope)/((1-10000*Quadsqrest-Quadintest)/100-quadminslope)
Quad_params_slope=Beta_params(mean(modQuadslopeest),var(modQuadslopeest))
Quad_alpha_slope=Quad_params_slope[1]
Quad_beta_slope=Quad_params_slope[2]


#Cubic
cubtype=cubtype[!is.na(cubtype)]
cub_type1_prob=sum(cubtype==1)/length(cubtype)
cub_type2_prob=sum(cubtype==2)/length(cubtype)
cub_type3_prob=sum(cubtype==3)/length(cubtype)
cub_type4_prob=sum(cubtype==4)/length(cubtype)

modcubintest=vector('numeric')
modcubslopeest=vector('numeric')
modcubsqrest=vector('numeric')
modcubcubest=vector('numeric')

for(j in 1:fitn){
i=Cubusevec[j]
if(cubtype[j]==1){
modcubintest[j]=cubintest[i]
modcubcubest[j]=cubcubest[i]/((1-cubintest[i])/250000)
slopemin=2500*(sqrt(3*cubcubest[i])-sqrt(abs(3*cubcubest[i]+(1-cubintest[i]-100^3*cubcubest[i]))/250000))^2
slopemax=2500*(sqrt(3*cubcubest[i])+sqrt(abs(3*cubcubest[i]+(1-cubintest[i]-100^3*cubcubest[i])/250000)))^2
modcubslopeest[j]=(cubslopeest[i]-slopemin)/(slopemax-slopemin)
sqrmax=min((1-cubintest[i]-100*cubslopeest[i]-1000000*cubcubest[i])/10000,sqrt(3*cubintest[i]*cubcubest[i]))
modcubsqrest[j]=(cubsqrest[i]+sqrt(3*cubintest[i]*cubcubest[i]))/(sqrmax+sqrt(3*cubintest[i]*cubcubest[i]))

}
if(cubtype[j]==2){

modcubintest[j]=cubintest[i]*2
modcubslopeest[j]=cubslopeest[i]/((1-cubintest[i])/100)
cubmax=min(1-cubintest[i]-100*cubslopeest[i],1-2*cubintest[i])/1000000
modcubcubest[j]=min(cubcubest[i],cubmax)/cubmax
sqrmax=(1-cubintest[i]-100*cubslopeest[i]-1000000*cubcubest[i])/10000
modcubsqrest[j]=(cubsqrest[i]-sqrt(3*cubintest[i]*cubcubest[i]))/(sqrmax--sqrt(3*cubintest[i]*cubcubest[i]))

}
if(cubtype[j]==3){

modcubintest[j]=cubintest[i]
modcubslopeest[j]=cubslopeest[i]/(3*(1-cubintest[i])/100)
cubmin=max(0,(50*cubslopeest[i]+cubintest[i]-1)/500000)
modcubcubest[j]=(cubcubest[i]-cubmin)/(cubintest[i]/30000-cubmin)
sqrmax=m(-sqrt(3*cubcubest[i]*cubslopeest[i]),-300*cubcubest[i],(1-cubintest[i]-100*cubslopeest[i]-1000000*cubcubest[i])/10000)
sqrmin=(-cubslopeest[i]-30000*cubcubest[i])/200
modcubsqrest[j]=(cubsqrest[i]-sqrmin)/(sqrmax-sqrmin)

}
if(cubtype[j]==4){

modcubintest[j]=cubintest[i]
modcubslopeest[j]=cubslopeest[i]/((1-cubintest[i])/50)
modcubcubest[j]=(cubcubest[i]-(50*cubslopeest[i]+cubintest[i]-1)/500000)/(-(50*cubslopeest[i]+cubintest[i]-1)/500000)
sqrmin=(-cubslopeest[i]-30000*cubcubest[i])/200
sqrmax=(1-cubintest[i]-100*cubslopeest[i]-1000000*cubcubest[i])/10000
if(sqrmin==sqrmax){
modcubsqrest[j]=0
}else{
modcubsqrest[j]=(cubsqrest[i]-sqrmin)/(sqrmax-sqrmin)
}
}
}

#Intercept Parameter
Cub_params_int=Beta_params(mean(modcubintest),var(modcubintest))
Cub_alpha_int=Cub_params_int[1]
Cub_beta_int=Cub_params_int[2]

#Slope Parameter
modcubslopeest=pmax(0.0,pmin(0.95,modcubslopeest))
Cub_params_slope=Beta_params(mean(modcubslopeest),var(modcubslopeest))
Cub_alpha_slope=Cub_params_slope[1]
Cub_beta_slope=Cub_params_slope[2]

#Square Parameter
modcubsqrest=pmax(0.05,pmin(0.95,modcubsqrest))
Cub_params_sqr=Beta_params(mean(modcubsqrest),var(modcubsqrest))
Cub_params_sqr=abs(Cub_params_sqr)
Cub_alpha_sqr=Cub_params_sqr[1]
Cub_beta_sqr=Cub_params_sqr[2]

#Cubic Parameter
modcubcubest=pmax(0.05,pmin(0.95,modcubcubest))
Cub_params_cub=Beta_params(mean(modcubcubest),var(modcubcubest))
Cub_alpha_cub=Cub_params_cub[1]
Cub_beta_cub=Cub_params_cub[2]

#Shannon
#cost parameter (gamma)
Shan_params_cost=Gamma_params(mean(Shancostest),var(Shancostest))
Shan_k=Shan_params_cost[1]
Shan_theta=Shan_params_cost[2]


#Tsallis
#cost parameter (gamma)
Tsal_params_cost=Gamma_params(mean(Tsalcostest),var(Tsalcostest))
Tsal_k_cost=Tsal_params_cost[1]
Tsal_theta_cost=Tsal_params_cost[2]

#Entropy Parameter (gamma)
Tsal_params_ent=Gamma_params(mean(Tsalentest),var(Tsalentest))
Tsal_k_q=Tsal_params_ent[1]
Tsal_theta_q=Tsal_params_ent[2]


#Normal
#cost parameter (gamma)
Norm_params_cost=Gamma_params(mean(Normcostest),var(Normcostest))
Norm_k=Norm_params_cost[1]
Norm_theta=Norm_params_cost[2]


#Define hyper parameters distributions (Dirichlet)
alpha=vector("numeric")
alpha[1]=1
alpha[2]=1
alpha[3]=1
alpha[4]=1
alpha[5]=1
alpha[6]=1
alpha[7]=1
alpha[8]=1
alpha[9]=1

#Draw data for MCMC
#Number of iterations
N=10000
M=sn*N

#Pick a distribution of models at random
props_list=list()
for(i in 1:N){
diridraw=rdirichlet(1,alpha)
props_list[[i]]= diridraw*activity/sum(diridraw*activity)
}

#Pick a list of model parameters at random

#Constant
Cons_perf=rbeta(M,Con_alpha,Con_beta)

#Binary
Bin_perf1=rbeta(M,Bin_alpha1,Bin_beta1)*0.8+0.2
Bin_perf2=Bin_perf1+(1-Bin_perf1)*rbeta(M,Bin_alpha2,Bin_beta2)
Bin_break=5+90*rbeta(M,Bin_alpha_break,Bin_beta_break)

#Affine with Break
AffBr_intercept1=rbeta(M,AffBr_alpha_int1,AffBr_beta_int1)*0.8+0.2
AffBr_break=5+90*rbeta(M,AffBr_alpha_break,AffBr_beta_break)
AffBr_slope1=rbeta(M,AffBr_alpha_slope1,AffBr_beta_slope1)*(1-AffBr_intercept1)/AffBr_break
AffBr_slope2=rbeta(M,AffBr_alpha_slope2,AffBr_beta_slope2)*((1-AffBr_intercept1-AffBr_break*AffBr_slope1)/(100-AffBr_break))
minint2=AffBr_intercept1+AffBr_break*AffBr_slope1-AffBr_slope2*AffBr_break
AffBr_intercept2=rbeta(M,AffBr_alpha_int2,AffBr_beta_int2)*(1-100*AffBr_slope2-minint2)+minint2

#Affine
Aff_intercept=rbeta(M,Aff_alpha_int,Aff_beta_int)*0.8+0.2
Aff_slope=(1-Aff_intercept)/100*rbeta(M,Aff_alpha_slope,Aff_beta_slope)

#Quadratic
Quad_intercept=rbeta(M,Quad_alpha_int,Quad_beta_int)*0.8+0.2
Quad_square=(Quad_intercept-1)/10000+rbeta(M,Quad_alpha_sqr,Quad_beta_sqr)*((1-Quad_intercept)/10000-(Quad_intercept-1)/10000)
Quadminslope=pmax(0,-200*Quad_square)
Quad_slope=rbeta(M,Quad_alpha_slope,Quad_beta_slope)*((1-10000*Quad_square-Quad_intercept)/100-Quadminslope)+Quadminslope

#Cubic
#1 is one or no real root, 2 is two roots <0, 3 is two roots >100,  4 is two roots one >100 one <0
Cub_type_draw=rmultinom(M,size=1,c(cub_type1_prob,cub_type2_prob,cub_type3_prob,cub_type4_prob))
Cub_type=vector('numeric')
for(i in 1:M){
Cub_type[i]=match(1,Cub_type_draw[,i])
}
Cub_intercept=vector('numeric')
Cub_slope=vector('numeric')
Cub_sqr=vector('numeric')
Cub_cub=vector('numeric')

for (i in 1:M){
if(Cub_type[i]==1){
Cub_intercept[i]=rbeta(1,Cub_alpha_int,Cub_beta_int)*0.8+0.2
Cub_cub[i]=max(0,rbeta(1,Cub_alpha_cub,Cub_beta_cub)*(1-Cub_intercept[i])/250000-0.000000000001)
slopemin=2500*(sqrt(3*Cub_cub[i])-sqrt(3*Cub_cub[i]+(1-Cub_intercept[i]-100^3*Cub_cub[i])/250000))^2
slopemax=2500*(sqrt(3*Cub_cub[i])+sqrt(3*Cub_cub[i]+(1-Cub_intercept[i]-100^3*Cub_cub[i])/250000))^2
Cub_slope[i]=max(0,rbeta(1,Cub_alpha_slope,Cub_beta_slope)*(slopemax-slopemin)+slopemin)
maxsqr=min((1-Cub_intercept[i]-100*Cub_slope[i]-1000000*Cub_cub[i])/10000,sqrt(3*Cub_intercept[i]*Cub_cub[i]))
minsqr=max(-sqrt(3*Cub_intercept[i]*Cub_cub[i]),-(Cub_intercept[i]+1000000*Cub_cub[i]+100*Cub_slope[i])/10000)
#Cub_sqr[i]=rbeta(1,Cub_alpha_sqr,Cub_beta_sqr)*(maxsqr-minsqr)+minsqr
Cub_sqr[i]=0.95*(maxsqr-minsqr)+minsqr

}
if(Cub_type[i]==2){
Cub_intercept[i]=rbeta(1,Cub_alpha_int,Cub_beta_int)/2
Cub_slope[i]=rbeta(1,Cub_alpha_slope,Cub_beta_slope)*(1-Cub_intercept[i])/100
Cub_cub[i]=max(0,rbeta(1,Cub_alpha_cub,Cub_beta_cub)*min((1-Cub_intercept[i]-100*Cub_slope[i])/1000000,(1-2*Cub_intercept[i])/1000000))
#Cub_sqr[i]=rbeta(1,Cub_alpha_sqr,Cub_beta_sqr)*((1-Cub_intercept[i]-100*Cub_slope[i]-1000000*Cub_cub[i])/10000-sqrt(3*Cub_slope[i]*Cub_cub[i]))+sqrt(3*Cub_slope[i]*Cub_cub[i])
Cub_sqr[i]=0.95*((1-Cub_intercept[i]-100*Cub_slope[i]-1000000*Cub_cub[i])/10000-sqrt(3*Cub_slope[i]*Cub_cub[i]))+sqrt(3*Cub_slope[i]*Cub_cub[i])

}
if(Cub_type[i]==3){
Cub_intercept[i]=rbeta(1,Cub_alpha_int,Cub_beta_int)
Cub_slope[i]=rbeta(1,Cub_alpha_slope,Cub_beta_slope)*3*(1-Cub_intercept[i])/100
cubmin=max(0,(50*Cub_slope[i]+Cub_intercept[i]-1)/500000)
Cub_cub[i]=rbeta(1,Cub_alpha_cub,Cub_beta_cub)*(Cub_slope[i]/30000-cubmin)+cubmin
sqrmin=(-Cub_slope[i]-30000*Cub_cub[i])/200
sqrmax=min(c(-sqrt(3*Cub_slope[i]*Cub_cub[i]),-300*Cub_cub[i],(1-Cub_intercept[i]-100*Cub_slope[i]-1000000*Cub_cub[i])/10000))
#Cub_sqr[i]=rbeta(1,Cub_alpha_sqr,Cub_beta_sqr)*(sqrmax-sqrmin)+sqrmin
Cub_sqr[i]=0.95*(sqrmax-sqrmin)+sqrmin
}
if(Cub_type[i]==4){
Cub_intercept[i]=rbeta(1,Cub_alpha_int,Cub_beta_int)
Cub_slope[i]=rbeta(1,Cub_alpha_slope,Cub_beta_slope)*(1-Cub_intercept[i])/50
Cub_cub[i]=rbeta(1,Cub_alpha_cub,Cub_beta_cub)*(-((50*Cub_slope[i]+Cub_intercept[i]-1)/500000))+(50*Cub_slope[i]+Cub_intercept[i]-1)/500000
#Cub_sqr[i]=rbeta(1,Cub_alpha_sqr,Cub_beta_sqr)*((1-Cub_intercept[i]-100*Cub_slope[i]-100^3*Cub_cub[i])/10000-(-Cub_slope[i]-30000*Cub_cub[i])/200)+(-Cub_slope[i]-30000*Cub_cub[i])/200
Cub_sqr[i]=0.95*((1-Cub_intercept[i]-100*Cub_slope[i]-100^3*Cub_cub[i])/10000-(-Cub_slope[i]-30000*Cub_cub[i])/200)+(-Cub_slope[i]-30000*Cub_cub[i])/200

}
}

#Shannon
Shan_cost=rgamma(M,Shan_k,scale=Shan_theta)

#Tsallis
Tsal_cost=rgamma(M,Tsal_k_cost,scale=Tsal_theta_cost)
Tsal_q=rgamma(M,Tsal_k_q,scale=Tsal_theta_q)

#Normal
Norm_cost=rgamma(M,Norm_k,scale=Norm_theta)

params_list=list()
for(i in 1:N){
params_list[[i]]=list()

for(j in 1:sn){
index=(j-1)*N+i
params_list[[i]][[j]]=list()
#Constant
params_list[[i]][[j]][[1]]=list(perf=Cons_perf[index])
#Binary
params_list[[i]][[j]][[2]]=list(perf1=Bin_perf1[index],breakp=Bin_break[index],perf2=Bin_perf2[index])
#Affine with break
params_list[[i]][[j]][[3]]=list(int1=AffBr_intercept1[index],slope1=AffBr_slope1[index],breakp=AffBr_break[index],int2=AffBr_intercept2[index],slope2=AffBr_slope2[index])
#Affine
params_list[[i]][[j]][[4]]=list(int=Aff_intercept[index],slope=Aff_slope[index])
#Quadratic
params_list[[i]][[j]][[5]]=list(int=Quad_intercept[index],slope=Quad_slope[i],sqr=Quad_square[index])
#Cubic
params_list[[i]][[j]][[6]]=list(int=Cub_intercept[index],slope=Cub_slope[index],sqr=Cub_sqr[index],cub=Cub_cub[index])
#Shannon
params_list[[i]][[j]][[7]]=list(alpha=Shan_cost[index])
#Tsallis
params_list[[i]][[j]][[8]]=list(alpha=Tsal_cost[index],sigma=Tsal_q[index])
#Normal
params_list[[i]][[j]][[9]]=list(a=Norm_cost[index])
}
}

#Draw random values for MCMC process
draws=runif((sn+1)*N)

##########################################################################################################
#construct likelihood function
#Data
data_dots <- as.list(mat.or.vec(n_subj,1));

#Define Tsallis Estimation parameters
tolerance_perf <- 0.00001; #sets distance performance can be from 0 or 1
tolerance_sigma <- 0.00001; #sets distance performance can be from 0 or 1

#create correct vecto, incorrect vector, interior state vector, non-interior state vector
correct_vec_list=list()
incorrect_vec_list=list()
interior_correct_vec_list=list()
non_interior_correct_vec_list=list()
interior_incorrect_vec_list=list()
non_interior_incorrect_vec_list=list()

for(j in 1:sn){
correct_vec=vector('numeric')
incorrect_vec=vector('numeric')
interior_correct_vec=vector('numeric')
non_interior_correct_vec=vector('numeric')
interior_incorrect_vec=vector('numeric')
non_interior_incorrect_vec=vector('numeric')
for(i in 1:100){
correct_vec[i]=sum((inc_dots[j,]==i)*(correct_dots[j,]))
incorrect_vec[i]=sum((inc_dots[j,]==i)*(1-correct_dots[j,]))
interior_correct_vec[i]=sum((inc_dots[j,]==i)*(correct_dots[j,])*(true_dots[j,] %in% c(39,40,41)))
interior_incorrect_vec[i]=sum((inc_dots[j,]==i)*(1-correct_dots[j,])*(true_dots[j,] %in% c(39,40,41)))
non_interior_correct_vec[i]=sum((inc_dots[j,]==i)*(correct_dots[j,])*(true_dots[j,] %in% c(38,42)))
non_interior_incorrect_vec[i]=sum((inc_dots[j,]==i)*(1-correct_dots[j,])*(true_dots[j,] %in% c(38,42)))
}


correct_vec_list[[j]]=correct_vec
incorrect_vec_list[[j]]=incorrect_vec
interior_correct_vec_list[[j]]=interior_correct_vec
non_interior_correct_vec_list[[j]]=non_interior_correct_vec
interior_incorrect_vec_list[[j]]=interior_incorrect_vec
non_interior_incorrect_vec_list[[j]]=non_interior_incorrect_vec

}


#Define normalizing constant
adj_like=vector('numeric')
for(i in 1:sn){
#correct_vec=correct_vec_list[[i]]
#incorrect_vec=incorrect_vec_list[[i]]
#optim_perf=correct_vec/(correct_vec+incorrect_vec)
#optim_like=sum(correct_vec*log(optim_perf)+incorrect_vec*log((1-optim_perf)))
#adj_like[i]=optim_like
adj_like[i]=0
}


#Now define the function
t_likelihood=function(props,params_set,k){

#t_like=vector('numeric')

#for debugging function
#props=props_mat[11,]
#params=params_list[[11]]
#props_mat=newpropsmat
#params_set=compparams
#for(k in 1:1){

params=params_set[[k]]

correct_vec=correct_vec_list[[k]]
incorrect_vec=incorrect_vec_list[[k]]
interior_correct_vec=interior_correct_vec_list[[k]]
non_interior_correct_vec=non_interior_correct_vec_list[[k]]
interior_incorrect_vec=interior_incorrect_vec_list[[k]]
non_interior_incorrect_vec=non_interior_incorrect_vec_list[[k]]

#Constant
if(activity[1]==1){
Cons_like=sum(correct_vec)*log(params[[1]]$perf)+sum(incorrect_vec)*log((1-params[[1]]$perf))
Cons_like=Cons_like-adj_like[k]
}else{
Cons_like=0
props[1]=0
}

#Binary
if(activity[2]==1){
Bin_like=sum(correct_vec[1:trunc(params[[2]]$breakp)])*log(params[[2]]$perf1)+sum(incorrect_vec[1:trunc(params[[2]]$breakp)])*log((1-params[[2]]$perf1))+sum(correct_vec[(trunc(params[[2]]$breakp)+1):100])*log(params[[2]]$perf2)+sum(incorrect_vec[(trunc(params[[2]]$breakp)+1):100])*log((1-params[[2]]$perf2))
Bin_like=Bin_like-adj_like[k]
}else{
Bin_like=0
props[2]=0
}

#Affine with Break
if(activity[3]==1){
AffBr_perf=pmax(0.000000000001,pmin(0.99999999999,c(params[[3]]$int1+params[[3]]$slope1*c(1:trunc(params[[3]]$breakp)),params[[3]]$int2+params[[3]]$slope2*c((trunc(params[[3]]$breakp)+1):100))))
AffBr_like=sum(correct_vec[1:100]*log(AffBr_perf)+incorrect_vec[1:100]*log(1-AffBr_perf))
AffBr_like=AffBr_like-adj_like[k]
}else{
AffBr_like=0
props[3]=0
}

#Affine
if(activity[4]==1){
Aff_perf=pmax(0.000000000001,pmin(0.99999999999,params[[4]]$int+params[[4]]$slope*c(1:100)))
Aff_like=sum(correct_vec[1:100]*log(Aff_perf)+incorrect_vec[1:100]*log(1-Aff_perf))
Aff_like=Aff_like-adj_like[k]
}else{
Aff_like=0
props[4]=0
}

#Quadratic
if(activity[5]==1){
Quad_perf=pmax(0.000000000001,pmin(0.99999999999,params[[5]]$int+params[[5]]$slope*c(1:100)+params[[5]]$sqr*c(1:100)^2))
Quad_like=sum(correct_vec[1:100]*log(Quad_perf)+incorrect_vec[1:100]*log(1-Quad_perf))
Quad_like=Quad_like-adj_like[k]
}else{
Quad_like=0
props[5]=0
}

#Third Degree Polynomial
if(activity[6]==1){
Cube_perf=pmax(0.000000000001,pmin(0.99999999999,params[[6]]$int+params[[6]]$slope*c(1:100)+params[[6]]$sqr*c(1:100)^2+params[[6]]$cub*c(1:100)^3))
Cube_like=sum(correct_vec[1:100]*log(Cube_perf)+incorrect_vec[1:100]*log(1-Cube_perf))
Cube_like=Cube_like-adj_like[k]
}else{
Cube_like=0
props[6]=0
}

#Shannon
if(activity[7]==1){
Shan_perf=pmax(0.000000000001,pmin(0.99999999999,exp(c(1:100)/params[[7]]$alpha)/(4+exp(c(1:100)/params[[7]]$alpha))))
Shan_like=sum(correct_vec*log(Shan_perf)+incorrect_vec*log((1-Shan_perf)))
Shan_like=Shan_like-adj_like[k]
}else{
Shan_like=0
props[7]=0
}

#Tsallis
if(activity[8]==1){
#find performance function
Tsal_perf=vector('numeric')
for(j in 1:100) {
			if(abs(params[[8]]$sigma-1)<tolerance_sigma) {
				perf_soln <- exp(j/params[[8]]$alpha)/(4+exp(j/params[[8]]$alpha));
			} else {
			
				#solve for performance
				solve_perf <- function(perf) {
					return(
						params[[8]]$alpha*params[[8]]$sigma/(params[[8]]$sigma-1)*(((1-perf)/4)^(params[[8]]$sigma-1)-perf^(params[[8]]$sigma-1))+j
					);
				}
				
				perf_soln <- try(as.numeric(uniroot(solve_perf,c(0.2,1),extendInt="downX")$root));
				#Looking at the graph, the only way for rootfinding to fail is if the root is greater than 1 (since "roots" smaller than 0.2 will never be chosen). If performance larger than 1 is computed, then this resets it to just below 1 so that a likelihood can actually be computed
				if("try-error" %in% class(perf_soln)) {
					perf_soln <- 1-tolerance_perf; 
				}
				}
			Tsal_perf[j]=perf_soln
			}

Tsal_perf=pmax(0.000000000001,pmin(0.99999999999,Tsal_perf))
Tsal_like=sum(correct_vec*log(Tsal_perf)+incorrect_vec*log((1-Tsal_perf)))
Tsal_like=Tsal_like-adj_like[k]
}else{
Tsal_like=0
props[8]=0
}

#Normal
if(activity[9]==1){
Norm_sqrtprec=vector('numeric')
Norm_inter_perf=vector('numeric')
Norm_non_inter_perf=vector('numeric')

for(j in 1:100) {
		#solve for sqrt of precision
		solve_sqrt_prec <- function(sqrt_prec) {
			return(params[[9]]$a*sqrt_prec - 2/5*dnorm(0.5*sqrt_prec)*j);
		}
		Norm_sqrtprec[j] <- uniroot(solve_sqrt_prec,c(0.001,100000))$root;
		}

Norm_inter_perf=pmax(0.000000000001,pmin(0.99999999999,pnorm(0.5,sd=1/Norm_sqrtprec)))
Norm_non_inter_perf=pmax(0.000000000001,pmin(0.99999999999,pnorm(0.5,sd=1/Norm_sqrtprec)-pnorm(-0.5,sd=1/Norm_sqrtprec)))

Norm_like=sum(interior_correct_vec*log(Norm_inter_perf)+interior_incorrect_vec*log(1-Norm_inter_perf)+non_interior_correct_vec*log(Norm_non_inter_perf)+non_interior_incorrect_vec*log(1-Norm_non_inter_perf))
Norm_like=Norm_like-adj_like[k]
}else{
Norm_like=0
props[9]=0
}

t_like=props[1]*exp(Cons_like)+props[2]*exp(Bin_like)+props[3]*exp(AffBr_like)+props[4]*exp(Aff_like)+props[5]*exp(Quad_like)+props[6]*exp(Cube_like)+props[7]*exp(Shan_like)+props[8]*exp(Tsal_like)+props[9]*exp(Norm_like)
return(log(t_like))

}
###########################################################################################################


#Avg props list
avgpropslist=list()

#Storage Vectors
propshist=list()
paramshist=list()
likehist=vector('numeric')

#initialize comparison values comparison
compprops=props_list[[1]]
compparams=params_list[[1]]
complike=vector("numeric")
for(k in 1:sn){
complike[k]=t_likelihood(compprops,compparams,k)
}

#start off the historiesmat
propshist[[1]]=compprops
paramshist[[1]]=compparams
likehist[1]=sum(complike)

#Start MCMC process
for(j in 1:N){

#define New proportions
newprops=props_list[[j]]

#check likelihood
newlike=vector("numeric")
for(k in 1:sn){
newlike[k]=t_likelihood(newprops,compparams,k)
}

if(draws[j]<exp(sum(newlike)-sum(complike))){
compprops=newprops
complike=newlike
#if replacements happens store in history
propshist[[length(propshist)+1]]=compprops
paramshist[[length(paramshist)+1]]=compparams
likehist[[length(likehist)+1]]=sum(complike)
}


#define new parameters
newparamsfull=params_list[[j]]

for(k in 1:sn){
#check likelihood
newparams=compparams
newparams[[k]]=newparamsfull[[k]]

newlike[k]=t_likelihood(compprops,newparams,k)

#check to see if replacement should happen and replace
if(draws[k*N+j]<exp(newlike[k]-complike[k])){
compparams=newparams
complike[k]=newlike[k]
#if replacements happens store in history
propshist[[length(propshist)+1]]=compprops
paramshist[[length(paramshist)+1]]=compparams
likehist[[length(likehist)+1]]=sum(complike)
}
print(j)
}

print(j)
print(j)
}

histlen=length(propshist)
plot(c(1:histlen),likehist,ylab="Log Likelihood", xlab="Iteration", main="Likelihood over Iterations")

#Find average proportions
#number of periods to check
n=histlen/2

histlen=length(propshist)
props_check_hist=list()
plot(c(1:histlen),likehist)
for(i in 1:n){
props_check_hist[[i]]=propshist[[histlen-n+i]]
}

avgpropsvec=rep(0,9)

for(i in 1:n){
avgpropsvec=avgpropsvec+props_check_hist[[i]]
}


avgpropsvec=avgpropsvec/(n)
avgpropsvec
which(avgpropsvec>1/9)


#Order 
#Constant, Binary, Affine Break, Linear, Quadratic, Cubic, Shannon, Tsallis, Normal
#fitn=10 gives  2 6 6  4  3  4  3  9  5
#fitn=20 gives  8 7 4  3  5  5  3  4  3
#fitn=42 gives  2 4 11 6  2  5  4  3  5

#For methodological explanation look at:
#https://stats.stackexchange.com/questions/163399/metropolis-hastings-algorithm-prior-vs-proposal-vs-numerator-of-bayes-theorem
