#graphs for presentation

#using lab subjects

#code for binning incentives
scatter_bin_width <- 10; #set to change bin width, preferably factor of 100
scatter_bin_num <- ceiling(100/scatter_bin_width);

#create vector of bin midpoints for graphing
bin_midpts_notrunc <- (1:scatter_bin_num)*scatter_bin_width - scatter_bin_width/2+0.5; #don't account for truncation at top
bin_midpts <- apply(as.matrix(bin_midpts_notrunc),c(1),min,mean(c(100,scatter_bin_width*(scatter_bin_num-1)+1))); #shift midpoint in top bin as necessary


#RATIONALITY
#not rational
bin_success_1 <- mat.or.vec(scatter_bin_num,1);
for(k in 1:scatter_bin_num) {
	bin_success_1[k] <- mean(correct_dots[1,intersect(which(inc_dots[1,]>(k-1)*scatter_bin_width),which(inc_dots[1,]<=k*scatter_bin_width))]);
}
plot(correct_dots[1,] ~ inc_dots[1,], main="Rejects NIAC (Lab Subject 1)",xlab="Incentive Level",ylab="Correct",pch=20);
points(bin_success_1~bin_midpts,add=TRUE);
b <- lpm3_reg_dots[[1]]$coefficients;
curve(b[1]+b[2]*x+b[3]*x^2+b[4]*x^3, add=TRUE);
dev.copy(pdf,"fail_ratl.pdf");
dev.off();

#rational
bin_success_19 <- mat.or.vec(scatter_bin_num,1);
for(k in 1:scatter_bin_num) {
	bin_success_19[k] <- mean(correct_dots[19,intersect(which(inc_dots[19,]>(k-1)*scatter_bin_width),which(inc_dots[19,]<=k*scatter_bin_width))]);
}
plot(correct_dots[19,] ~ inc_dots[19,], main="Fails to reject NIAC (Lab Subject 19)",xlab="Incentive Level",ylab="Correct",pch=20);
points(bin_success_19~bin_midpts,add=TRUE);
b <- lpm3_reg_dots[[19]]$coefficients;
curve(b[1]+b[2]*x+b[3]*x^2+b[4]*x^3, add=TRUE);
dev.copy(pdf,"succ_ratl.pdf");
dev.off();


#STRICT RATIONALITY
#not strictly rational
bin_success_32 <- mat.or.vec(scatter_bin_num,1);
for(k in 1:scatter_bin_num) {
	bin_success_32[k] <- mean(correct_dots[32,intersect(which(inc_dots[32,]>(k-1)*scatter_bin_width),which(inc_dots[32,]<=k*scatter_bin_width))]);
}
plot(correct_dots[32,] ~ inc_dots[32,], main="Fails to Reject Non-Responsiveness (Lab Subject 32)",xlab="Incentive Level",ylab="Correct",pch=20);
points(bin_success_32~bin_midpts,add=TRUE);
b <- lpm_reg_dots[[32]]$coefficients;
curve(b[1]+b[2]*x, add=TRUE);
dev.copy(pdf,"fail_str.pdf");
dev.off();

#strictly rational
bin_success_26 <- mat.or.vec(scatter_bin_num,1);
for(k in 1:scatter_bin_num) {
	bin_success_26[k] <- mean(correct_dots[26,intersect(which(inc_dots[26,]>(k-1)*scatter_bin_width),which(inc_dots[26,]<=k*scatter_bin_width))]);
}
plot(correct_dots[26,] ~ inc_dots[26,], main="Rejects Non-Responsiveness (Lab Subject 26)",xlab="Incentive Level",ylab="Correct",pch=20);
points(bin_success_26~bin_midpts,add=TRUE);
b <- lpm_reg_dots[[26]]$coefficients;
curve(b[1]+b[2]*x, add=TRUE);
dev.copy(pdf,"succ_str.pdf");
dev.off();


#BREAKS
#Has break
plot(correct_dots[45,] ~ inc_dots[45,], main="Has break (Online Subject 45)",xlab="Incentive Level",ylab="Correct",pch=20);
b <- breaks_reg_dots[[39]]$coefficients;
curve(b[1]+b[2]*x,1,breaks_dots[[45]]$breakpoints,add=TRUE);
curve(b[1]+b[3]+(b[2]+b[4])*x,breaks_dots[[45]]$breakpoints,100,add=TRUE);
dev.copy(pdf,"fail_nobreak.pdf");
dev.off();

#no break


#BAR PLOTS OF ERROR DISTANCES
#true error distances
barplot(table(dist_dots[85,]), main="Distribution of Error Distances: Online Subject 85", xlab="Error Distance", ylab="Frequency");
#shannon error distances
graph_err <- 200*error_shannon_dots[85,];
names(graph_err) <- -4:4;
barplot(graph_err,main="Theoretical Distribution of Error Distances: Online Subject 85", xlab="Error Distance", ylab="Frequency");

