#MONOTONE NONPARAMETRIC REGRESSIONS

install.packages("monreg");
library(monreg);

scatter_bin_width <- 10; #set to change bin width, preferably factor of 100
scatter_bin_num <- ceiling(100/scatter_bin_width);

#create vector of bin midpoints for graphing
bin_midpts_notrunc <- (1:scatter_bin_num)*scatter_bin_width - scatter_bin_width/2+0.5; #don't account for truncation at top
bin_midpts <- apply(as.matrix(bin_midpts_notrunc),c(1),min,mean(c(100,scatter_bin_width*(scatter_bin_num-1)+1))); #shift midpoint in top bin as necessary

#RUN TO END OF LAB PREAMBLE CODE FIRST
#for lab subjects, use .2 as bandwidth
monreg_lab_dots <- as.list(mat.or.vec(n_subj,1));
for(i in 1:n_subj) {
	
	for(k in 1:scatter_bin_num) {
		bin_success[i,k] <- mean(correct_dots[i,intersect(which(inc_dots[i,]>(k-1)*scatter_bin_width),which(inc_dots[i,]<=k*scatter_bin_width))]);
	}
	
	monreg_lab_dots[[i]] <- monreg(inc_dots[i,],correct_dots[i,],hd=.2,hr=.2);
	plot(inc_dots[i,],correct_dots[i,],pch=20,xlab="Incentive Level",ylab="Correct",main=paste("Monotone Nonparametric Regression: Subject ",i,sep=""));
	points(bin_success[i,]~bin_midpts,add=TRUE);
	lines(spline(monreg_lab_dots[[i]]$t,monreg_lab_dots[[i]]$estimation));
	dev.copy(pdf,paste("mon_nonparam_lab_",i,".pdf",sep=""));
	dev.off();
}


#RUN TO END OF ONLINE PREAMBLE CODE FIRST
#for online subjects, use .1 as bandwidth
monreg_onl_dots <- as.list(mat.or.vec(n_subj,1));
for(i in 1:n_subj) {
	monreg_onl_dots[[i]] <- monreg(inc_dots[i,],correct_dots[i,],hd=.1,hr=.1);
	plot(inc_dots[i,],correct_dots[i,],pch=20,xlab="Incentive Level",ylab="Correct",main=paste("Monotone Nonparametric Regression: Subject ",i,"",sep=""));
	lines(spline(monreg_onl_dots[[i]]$t,monreg_onl_dots[[i]]$estimation));
	dev.copy(pdf,paste("mon_nonparam_onl_",i,".pdf",sep=""));
	dev.off();
}