#MULTIOMIAL LOGIT MODELS
#separating lab and online
#run after all other analysis

##stargazer [for latex output]
##nnet [for multinomial logit]
##DAMisc [for average effects]

install.packages("stargazer");
install.packages("nnet");
install.packages("DAMisc");

library(stargazer);
library(nnet);
library(DAMisc);

ratl <- ((1:n_subj) %in% rat_subj) + 0;
bacc <- (substr(lvl_edu,1,1) %in% c("B","M","D")) + 0;
str_ratl <- ((1:n_subj) %in% str_mon_subj) + 0;

#set shannon to base, binary to 2, tsallis to 3, normal to 4
bmodel <- rep(NA,n_subj);
for(i in 1:n_subj) {
	if(best_model_dots[i] == 2) {
		bmodel[i] <- 2;
	} else if(best_model_dots[i] == 7) {
		bmodel[i] <- 1;
	} else if(best_model_dots[i] == 9) {
		bmodel[i] <- 3;
	} else {
		bmodel[i] <- 4;
	}
}

multi_ratl <- multinom(ratl ~ age + male + bacc + epn + is20 + dots_first, na.action="na.omit"); #rationality
multi_str <- multinom(str_ratl[rat_subj] ~ age[rat_subj] + male[rat_subj] + bacc[rat_subj] + epn[rat_subj] +  is20[rat_subj] + dots_first[rat_subj], na.action="na.omit"); #responsiveness
multi_nonc <- multinom(bmodel[str_mon_subj] ~ age[str_mon_subj] + male[str_mon_subj] + bacc[str_mon_subj] + epn[str_mon_subj] +  is20[str_mon_subj] + dots_first[str_mon_subj], na.action="na.omit"); #model selection
