##RUN LAB OR ONLINE FIRST
##NIAS

#check diag entry is maximal (probabilistically) in each column using bootstrap

nias_table <- as.list(mat.or.vec(n_subj,1)); #table of responses by state
nias_max <- as.list(mat.or.vec(n_subj,1)); #stores which entry in each col. of table was maximal
nias_true <- mat.or.vec(n_subj,1); #satisifes nias?
nias_pvals_tables <- as.list(mat.or.vec(n_subj,1)); #stores all p-values for each subject
nias_pval_min <- mat.or.vec(n_subj,1); #store p-value

#online subjects 14,99 never answered 42, so special code for them
#no42 <- c(14,99); #web
#no42 <- c(0); #lab

#seed set using as.numeric(as.POSIXct(Sys.time())) to get current UNIX time
set.seed(1475990373);

#set number of bootstrap iterations
iterations <- 499;

for(i in 1:n_subj) {
	
	nias_table[[i]] <- table(true_dots[i,],chose_dots[i,]);
	chosen_responses <- as.numeric(colnames(nias_table[[i]]));
	reject_nias <- rep(NA,dim(nias_table[[i]])[2]);
	
	nias_pvals_tables[[i]] <- rep(NA,dim(nias_table[[i]])[2]);

	#check column by column
	for(k in 1:dim(nias_table[[i]])[2]) {
		total_resp <- sum(nias_table[[i]][,k]); #number of response k

		#generate bootstrap samples
		rgen <- matrix(runif(iterations*total_resp),nrow=iterations,ncol=total_resp);
		assign_val <- function(x) {
			if(total_resp*x <= nias_table[[i]][1,k]) {
				return(38);
			} else if((total_resp*x > nias_table[[i]][1,k]) & (total_resp*x <= nias_table[[i]][1,k]+nias_table[[i]][2,k])) {
				return(39);
			} else if((total_resp*x > nias_table[[i]][1,k]+nias_table[[i]][2,k]) & (total_resp*x <= nias_table[[i]][1,k]+nias_table[[i]][2,k]+nias_table[[i]][3,k])) {
				return(40);
			} else if((total_resp*x > nias_table[[i]][1,k]+nias_table[[i]][2,k]+nias_table[[i]][3,k]) & (total_resp*x <= nias_table[[i]][1,k]+nias_table[[i]][2,k]+nias_table[[i]][3,k]+nias_table[[i]][4,k])) {
				return(41);
			} else {
				return(42);
			}
		}
		boot_samples <- apply(rgen,c(1,2),assign_val);

		#test bootstrap samples
		is_maximal <- function(x) {
			resp_counts <- table(x);
			if(chosen_responses[k] %in% as.numeric(names(which(resp_counts==max(resp_counts))))) {
				return(1);
			} else {
				return(0);
			}
		}
		boot_nias <- apply(boot_samples,1,is_maximal); #check whether right response is most common
		
		nias_pvals_tables[[i]][k] <- sum(boot_nias)/(iterations+1);

		if(sum(boot_nias) <=  0.05*(iterations+1)) {
			reject_nias[k] <- 1;
		} else {
			reject_nias[k] <- 0;
		}
	}
	
	if(1 %in% reject_nias) {
		nias_true[i] <- 0;
	} else {
		nias_true[i] <- 1;
	}
	
	nias_pval_min[i] <- min(nias_pvals_tables[[i]]);
	
	#debug, comment out
	print(i);
}

nias_subj <- which(nias_true==1);


##HISTOGRAM OF MINIMUM P-VALUE
hist(nias_pval_min, breaks=(0:20)/20, main="Histogram of Minimum p-values for NIAS Tests", xlab="p-value", ylim=c(0,40));

