#######
#######
#One-tailed t-test

#first get rational subjects (run after dsf and nias)
rat_subj <- intersect(mon_subj,nias_subj);

##RUN AFTER RUNNING LPMs

#over whole range
t_stat <- rep(NA,n_subj);
pval_ttest <- rep(NA,n_subj);

for(i in 1:n_subj) {
	t_stat[i] <- lpm_reg_dots[[i]]$coefficients[2]/coef(lpm_reg_sum_dots[[i]])[2,2];
	pval_ttest[i] <- pt(t_stat[i],lpm_reg_dots[[i]]$df.residual,lower.tail=FALSE);
}

str_mon_everywhere <- (pval_ttest <= 0.05)+0;

#table str_mon[mon_subj]

#str_mon_subj_everywhere <- intersect(mon_subj[which(str_mon[mon_subj]==1)],nias_subj[which(str_mon[nias_subj]==1)]);



#over each half (var name is "quar" because it used to be on quarters)
t_stat_quar <- matrix(nrow=n_subj,ncol=2);
pval_ttest_quar <- matrix(nrow=n_subj,ncol=2);

for (i in 1:n_subj) {
	for(j in 1:2) {
		#below 50 and above 50
		regressors <- intersect(which(inc_dots[i,] <= 50*j),which(inc_dots[i,] > 50*(j-1)));

		#compute one-sided t-stats
		unadj_reg <- lm(correct_dots[i,regressors]~inc_dots[i,regressors]);
		het_weights <- apply(as.matrix(fitted(unadj_reg)),1,lpm_weights);
		adj_reg <- lm(correct_dots[i,regressors]~inc_dots[i,regressors],weights=het_weights);
		t_stat_quar[i,j] <- adj_reg$coefficients[2]/coef(summary(adj_reg))[2,2];
		pval_ttest_quar[i,j] <- pt(t_stat_quar[i,j],adj_reg$df.residual,lower.tail=FALSE);
	}
}

str_mon_quar <- (pval_ttest_quar<=0.05)+0;

#check if str mon on whole set or on a half
str_mon_anywhere <- (rowSums(cbind(str_mon_everywhere,str_mon_quar)))+0;

str_mon_subj <- intersect(which(str_mon_anywhere>0),rat_subj);




##WHO IS FLAT
flat_subj <- setdiff(mon_subj,str_mon_subj);
point2 <- apply(correct_dots,1,t.test,alternative="two.sided",mu=0.2);
flat_tval = rep(NA,n_subj);
for(i in 1:n_subj) {
	flat_tval[i] <- point2[[i]]$p.value;
}
flat_signif = (flat_tval<=0.05)+0;
table(flat_signif[flat_subj]);



##HISTOGRAM OF MINIMUM P-VALUE
pval_ttest_min <- apply(cbind(pval_ttest,pval_ttest_quar),1,min);
hist(pval_ttest_min[rat_subj], breaks=(0:20)/20, main="Histogram of Minimum p-values for Responsiveness Tests", xlab="p-value", ylim=c(0,50));

